# pac01_ridgeback

A custom repository for the PAC01 Ridgeback robot.  Complete with a (Warthog style) Tower, Jetson TX2, Dual GEN3 Manipulators, Zed Stereo Camera, FLIR PTU Module, Velodyne VLP-16 and Microphone Array.

![The robot rendered in RVIZ](doc/pac01_ridgeback.png "The robot")


## Controlling the PTZ

The PTZ can be controlled by publishing to the `/ptu/cmd` topic:

```bash
$ rostopic pub /ptu/cmd sensor_msgs/JointState "header:
  seq: 0
  stamp: {secs: 0, nsecs: 0}
  frame_id: ''
name: ['ptu_pan', 'ptu_tilt']
position: [0.3, -0.2]
velocity: [0.1, 0.1]
effort: [0, 0]" -1
```


## Opening and closing the grippers

The left and right grippers can be opened/closed by publishing to the
`/{left|right}_kinova_arm/robotiq_2f_85_gripper_controller/gripper_cmd/goal` topics:

```bash
$ rostopic pub /right_kinova_arm/robotiq_2f_85_gripper_controller/gripper_cmd/goal control_msgs/GripperCommandActionGoal "
goal:
 command:
  position: 0.8
  max_effort: 1.0" -1
```

The position range is 0.0 to 0.8, with 0.8 being fully closed and 0.0 being fully open.

The arms must be running for the grippers to operate (see below)


## Controlling the arms

The arms are configured to operate with MoveIt.  After powering-on the robot, turn on the arms, and log into the
robot.  Then run

```bash
roslaunch pac01_ridgeback_bringup pac01_gen3.launch
```

This will start the drivers for the arms, as well as the MoveIt planner.  You can then connect your remote PC to
the robot and use the MoveIt planner in Rviz to control the arms.
